#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios::sync_with_stdio(0); cin.tie(0);
    int n, q;
    cin>>n>>q;
    long long d[n];
    int p[n];
    long long k[q];
    for (int i = 0; i<n; i++)
    {
        cin>>d[i]>>p[i];
    }
    long long br = 0;
    long long sigpoj = 0;
    for (int i = 0; i<q; i++)
    {
        cin>>k[i];
    }
    for (int i = 0; i<q; i++)
    {
        while(d[br]<k[i]&&br<n)
        {
            if (p[br]<k[i]-d[br])
            {
                sigpoj+=p[br++];
            }
            else
            {
                cout<<sigpoj+k[i]-d[br]+1<<endl;
                break;
            }
        }
    }


}